<template>
  <v-container>
    <v-row>
      <v-col cols="12">
        <v-data-table
          :headers="headers"
          :items="forms"
          sort-by="calories"
          class="elevation-1"
          :loading="loading"
        >
          <template #top>
            <v-toolbar flat>
              <v-toolbar-title>{{ $t('forms.respuestas') }}</v-toolbar-title>
              <v-spacer></v-spacer>
              <v-btn color="primary" class="mr-2" :to="`/admin/forms/list`">
                {{ $t('forms.regresar') }}
              </v-btn>
              <v-dialog v-model="dialogDelete" max-width="500px">
                <v-card>
                  <v-toolbar flat>
                    <v-toolbar-title>{{
                      $t('forms.eliminar-respuestas')
                    }}</v-toolbar-title>
                  </v-toolbar>

                  <v-card-text class="pa-4">
                    {{ $t('forms.deleteAnswersText') }}
                  </v-card-text>
                  <v-card-actions>
                    <v-spacer />
                    <v-btn color="secondary" text @click="closeDelete">
                      {{ $t('forms.cancel') }}
                    </v-btn>
                    <v-btn color="primary" @click="deleteItemConfirm">
                      {{ $t('forms.delete') }}
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
            </v-toolbar>
          </template>
          <template #[`item.actions`]="{ item }">
            <v-btn
              icon
              :to="`/admin/forms/answers/${$route.params.form}/${item.id}`"
            >
              <v-icon small> mdi-eye </v-icon>
            </v-btn>
            <v-btn icon @click="deleteItem(item)">
              <v-icon small> mdi-delete </v-icon>
            </v-btn>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
/* eslint-disable vue/valid-v-slot */

export default {
  data: () => ({
    loading: true,
    dialogDelete: false,
    headers: [
      {
        text: 'ID',
        align: 'start',
        sortable: false,
        value: 'id',
      },
      { text: 'Acciones', value: 'actions', sortable: false },
    ],
    forms: [],
  }),
  watch: {
    dialogDelete(val) {
      val || this.closeDelete()
    },
  },
  mounted() {
    this.initialize()
  },
  methods: {
    async initialize() {
      const self = this
      await this.$fire.firestore
        .collection(`forms/${this.$route.params.form}/answers`)
        .get()
        .then((querySnapshot) => {
          querySnapshot.forEach(function (doc) {
            self.forms.push({ id: doc.id, ...doc.data() })
          })
          self.loading = false
        })
        .catch((error) => {
          // eslint-disable-next-line no-console
          console.error('Error getting documents: ', error)
        })
    },
    deleteItem(item) {
      this.editedIndex = this.forms.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialogDelete = true
    },
    async deleteItemConfirm() {
      this.forms.splice(this.editedIndex, 1)
      await this.$fire.firestore
        .collection(`forms/${this.$route.params.form}/answers`)
        .doc(this.editedItem.id)
        .delete()
        .then(() => {
          this.closeDelete()
        })
        .catch((error) => {
          console.error('Error deleting documents: ', error)
          this.closeDelete()
        })
    },
    close() {
      this.dialog = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },
    closeDelete() {
      this.dialogDelete = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },
    save() {
      if (this.editedIndex > -1) {
        Object.assign(this.forms[this.editedIndex], this.editedItem)
      } else {
        this.forms.push(this.editedItem)
      }
      this.close()
    },
  },
}
</script>
